#include <stdio.h> 
#include <string.h> 
#include <stdlib.h> 

char **lineptr; 

int readlines( int *nlines); 

void writelines(char **lineptr, int nlines); 


void qsort_(char **lineptr, int left, int right); 

/* sort input lines */ 
main(){
  int nlines = 2; /* number of lines read */ 
  lineptr = calloc(nlines, sizeof(char*)); 
  printf("Please input a few lines, and they will be printed out sorted\n"); 
  
  if((nlines = readlines( &nlines)) >= 0) {
    qsort_(lineptr, 0, nlines - 1); 
    writelines(lineptr, nlines); 
    free(lineptr); 
    return 0; 
  }
  else {
    free(lineptr); 
    printf("error in readlines()  \n"); 
    return 1; 
  }
}


#define MAXLEN 1000 /* max length of any input line */ 
int getline_(char *, int); 

/* readlines: read input lines */ 
int readlines(  int *maxlines) {
  int len, nlines; 
  char *p, line[MAXLEN]; 
  
  nlines = 0; 
  while ((len = getline_(line, MAXLEN)) > 0) 
    if ( (p = malloc (len)) == NULL ) 
      return -1; 
    else {
      if (nlines >= *maxlines){
	*maxlines *= 2; 
	lineptr = (char **) realloc(lineptr, (*maxlines) * sizeof(char *));  
      } 
      line[len - 1] = '\0'; 
      strcpy (p, line); 
      lineptr[nlines++] = p; 
    }
  return nlines; 
}

/* writelines: write output lines */ 
void writelines(char *lineptr[], int nlines) {
  int i; 
  for (i = 0; i < nlines; i ++) 
    printf("%s\n", lineptr[i]); 
}


